// Use Foreach
import { foreach, importz } from "../kit";

// For Registry
function alternate(mode) {
  // Multi Projects
  if (process.env.rc.projects) {
    // Get Config
    const { registry, projects } = process.env.rc.projects;

    // Set Endless
    const endless = {};

    // Projects Loop
    foreach(projects, (check, project) => {
      // No Check No Project
      if (!check) {
        return;
      }

      // Insert Project to Endless
      endless[project] = {};

      // Get Keys of Registry
      const keys = Object.keys(registry).filter(mode => registry[mode]);

      // Registry Importz
      importz(keys, (mode, cip) => {
        // Set Endless
        endless[project][mode] = cip(require(`#/${project}/registry/${mode}`));
      });
    });

    // Return
    return endless;
  }
}

// Export
export default alternate;

// function alternate(mode) {
//   if (mode === "host") {
//     try {
//       return require.context(`@registry`, true, /host.js$/);
//     } catch (e) {}
//   }
//   if (mode === "api") {
//     try {
//       return require.context(`@registry`, true, /api.js$/);
//     } catch (e) {}
//   }
//   if (mode === "route") {
//     try {
//       return require.context(`@registry`, true, /route.js$/);
//     } catch (e) {}
//   }
//   if (mode === "store") {
//     try {
//       return require.context(`@registry`, true, /store.js$/);
//     } catch (e) {}
//   }
//   if (mode === "mixin") {
//     try {
//       return require.context(`@registry`, true, /mixin.js$/);
//     } catch (e) {}
//   }
// }
//
// // Export
// export default alternate;
